!Program to print the reduced system coordinates for SFG calculation


program aa 
 implicit none

 character(len=300) :: file1 
 character(len=5),allocatable :: atm(:),atmtypes(:)
 character(len=5) :: tmpatm 

 integer :: i,j,totatoms,totpalmitic,req_water,count,maxbin,nmol_acid,natoms_acid,nmol_water,nosplit
 integer :: natoms_water,nmol_anion,natoms_anion,nmol_cation,natoms_cation,nfiles,x,frame_no
 integer :: count_frames,hist,part_hist,counter,ifile,natoms_xxx,ac,an,ss,pp,jj,ncount_wat
 integer ::iframe,dummyint,kk,ll,imol,iatom,tmp_totatoms,mm,file_pos_cmd,totframes,totframes1,noframes_split

 integer,allocatable :: typ(:),store_watid(:)
 character(len=500),allocatable::dump_file(:)


 real(kind=8) :: com(3),box(3),rz1,rz2,binwidth,box2,dr(3),r
 real(kind=8),allocatable :: coor(:,:),pos(:,:,:,:) 

 real(kind=8) :: dt,t,tmpr
 integer :: nstep,noatmtypes 
 character(500),allocatable :: dump_files(:)
 integer, allocatable :: nframes(:),nskip(:),modtyp(:,:)

 call getarg(1,file1)
 open(unit=1,file=file1,action='read')

 open(unit=55555,file='WATER.MOLINDEX',action='write') 

 file_pos_cmd=100 
! open(unit=file_pos_cmd,file='INP_CRD',action='write') 


 read(1,*)nmol_acid
 read(1,*)natoms_acid
 read(1,*)nmol_water
 read(1,*)natoms_water
 read(1,*)nmol_anion
 read(1,*)natoms_anion
 read(1,*)nmol_cation
 read(1,*)natoms_cation

 totatoms=nmol_acid*natoms_acid+nmol_water*natoms_water+nmol_anion*natoms_anion+nmol_cation*natoms_cation
 totpalmitic=nmol_acid*natoms_acid+nmol_anion*natoms_anion 

 read(1,*) box(:) 
 read(1,*) noatmtypes
 allocate(atmtypes(noatmtypes)) 

 read(1,*) atmtypes(:)
 read(1,*) nosplit             ! no of files to split into 

 read(1,*)nfiles



! write(*,*) 'enter water molecules'
! read(*,*) req_water
 req_water=936

  allocate(store_watid(req_water))

 binwidth=0.05d0 
 dt=0.002d0    !ps 

 box2=box(3)/2 
 tmpr=0.d0 

 
 maxbin=int(box(3)/binwidth/2.d0)

 allocate(dump_file(nfiles),nframes(nfiles),nskip(nfiles))
 allocate(atm(totatoms),coor(totatoms,3))
 allocate(typ(totatoms))
 allocate(modtyp(2,natoms_acid),pos(2,nmol_acid,natoms_acid,3)) 


! read dump filenames
 do i=1,nfiles
   read(1,*)dump_file(i),nframes(i),nskip(i)
 enddo
 totframes=sum(nframes)
 totframes1=sum(nskip)
 totframes=totframes-totframes1 

 noframes_split=totframes/nosplit

 frame_no=0; nstep=0 
 hist=0 ; part_hist=0 
 counter=0
 pp=0
 do ifile=1,nfiles
   open(unit=10+ifile,file=dump_file(ifile),action='read')

   do i=1,nskip(ifile)
     do j=1,totatoms+9
        read(10+ifile,*)
     enddo
   enddo

   nframes(ifile)=nframes(ifile)-nskip(ifile)

   write(*,*) 'working on file no ',ifile,' ',trim(adjustl(dump_file(ifile))),' ... '

   do iframe=frame_no+1,frame_no+nframes(ifile)
 
    if(mod(nstep,noframes_split)==0) pp=pp+1

      nstep=nstep+1 

     if(mod(nstep,100)==0) write(*,*) 'nstep   ',nstep 

      do i=1,9
         read(10+ifile,*)
      enddo

      do i=1,totatoms
         read(10+ifile,*)j,dummyint,typ(j),coor(j,:)
        coor(j,1)=coor(j,1)-box(1)*anint(coor(j,1)/box(1))
        coor(j,2)=coor(j,2)-box(2)*anint(coor(j,2)/box(2))
        
      enddo

! zero the COM
      com=0.d0 
      do i=1,totatoms
         com=com+coor(i,:) 
      enddo 
      
      com=com/real(totatoms) 
      
      
      do i=1,totatoms
         coor(i,3)=coor(i,3)-com(3)
      enddo 


      kk=1 ;  ll=2 ; tmp_totatoms=0 ; an=0 ; ac=0 
 ! adding this part to identify the molecule -- palmitic acid or palmitate 
      do j=1,nmol_acid+nmol_anion
        dr=coor(kk,:)-coor(ll,:)
        dr=dr-box*anint(dr/box) 
        r=dot_product(dr,dr)

!write(*,*) 'distance',dsqrt(r) 

        if(nmol_anion==0) then
           natoms_xxx= natoms_acid 
           ac=ac+1 
           ss=ac
           x=1
        endif 
           
        if(nmol_acid==0) then
          natoms_xxx= natoms_anion
          an=an+1 
          ss=an 
          x=2 
        endif

        if(nmol_anion/=0.and.nmol_acid/=0) then 
          if(r<=1.1d0*1.1d0) then 
             natoms_xxx=natoms_acid
             ac=ac+1 
             ss=ac
             x=1
           else 
             natoms_xxx=natoms_anion
             an=an+1 
             ss=an 
             x=2 
          endif 
        endif
!write(*,*) x,ss 
        kk=kk+natoms_xxx
        ll=ll+natoms_xxx

        do i=1,natoms_xxx

          mm=tmp_totatoms+i 
          pos(x,ss,i,:)=coor(mm,:)
          modtyp(x,i)=typ(mm)

        enddo

        tmp_totatoms=tmp_totatoms+natoms_xxx 
      enddo 

!   palmitates and palmitic acid coordinates are collected 

! print coordinates for monolayer

      t=nstep*dt 
     
      write(file_pos_cmd+pp,'(i10,1f15.7,i10)') nstep, t,3600 
      write(file_pos_cmd+pp,'(3f20.10)') box(1),tmpr,tmpr
      write(file_pos_cmd+pp,'(3f20.10)') tmpr,box(2),tmpr
      write(file_pos_cmd+pp,'(3f20.10)') tmpr,tmpr,box(3) 

! palmitic acid 
      do imol=1,nmol_acid
!        do iatom = 1, natoms_acid
        do iatom = 1, 11
          tmpatm=atmtypes(modtyp(1,iatom))
          if(iatom==11) tmpatm="HC" 
          write (file_pos_cmd+pp,'(a8,3f15.7)') tmpatm,pos(1,imol,iatom,:) 
!          enddo
        enddo 
      enddo 

!palmitate 
     if(nmol_anion/=0) then 
      do imol=1,nmol_anion
!        do iatom = 1, natoms_anion 
        do iatom = 1, 10
          tmpatm=atmtypes(modtyp(2,iatom))
          if(iatom==10) tmpatm="HC" 
          write (file_pos_cmd+pp,'(a8,3f15.7)') tmpatm,pos(2,imol,iatom,:)
        enddo 
!        enddo
      enddo 

! Na 

        do iatom = totpalmitic+1, totatoms

           if(trim(adjustl(atmtypes(typ(iatom))))=="Na") then

              write (file_pos_cmd+pp,'(a8,3f15.7)') atmtypes(typ(iatom)),coor(iatom,:) 

           endif 

        enddo 

      endif

! water 
      count=0 ; 
      write(55555,*) 'frame = ',nstep 
      do i=maxbin,0,-1
      
        rz1=i*binwidth
        rz2=(i+1)*binwidth
        ncount_wat=0 
        do j=totpalmitic+1,totatoms
      
           if(trim(adjustl(atmtypes(typ(j))))=="OW") then
             ncount_wat=ncount_wat+1
             if(abs(coor(j,3))<rz2.and.abs(coor(j,3))>=rz1) then
      
                do iatom = 0, 2
                  write (file_pos_cmd+pp,'(a8,3f15.7)') atmtypes(typ(j+iatom)),coor(j+iatom,:) 
                enddo 
        
                count=count+1 
                 store_watid(count)=ncount_wat
!                store_watid(count)=(j-totpalmitic+2)/3
        
!                write(*,*) rz1 
        
                 if(count+1>req_water) goto 1000          ! done 
        
             endif 
          endif
      
        enddo
      
      enddo 

    1000 continue

    do jj=1,count
      write(55555,*) store_watid(jj)
    enddo

    enddo     ! frames 

 enddo    ! files  

 8  format(1x,a3,3(f14.7,1x))

end program aa

