!Program to convert lammps trajectory into the POSITION_CMD which is the format
!required for spectral analysis codes 
! It prints only the water molecules 

program aa 
 implicit none

 character(len=300) :: file1 
 character(len=5),allocatable :: atm(:),atmtypes(:)
 character(len=5) :: tmpatm 

 integer :: i,j,totatoms,totpalmitic,req_water,count,maxbin,nmol_acid,natoms_acid,nmol_water,nosplit
 integer :: natoms_water,nmol_anion,natoms_anion,nmol_cation,natoms_cation,nfiles,x,frame_no,tott
 integer :: count_frames,hist,part_hist,counter,ifile,natoms_xxx,ac,an,ss,pp,jj
 integer ::iframe,dummyint,kk,ll,imol,iatom,tmp_totatoms,mm,file_pos_cmd,totframes,totframes1,noframes_split

 integer,allocatable :: typ(:),store_watid(:)
 character(len=500),allocatable::dump_file(:)


 real(kind=8) :: com(3),box(3),rz1,rz2,binwidth,box2,dr(3),r
 real(kind=8),allocatable :: coor(:,:),pos(:,:,:,:) 

 real(kind=8) :: dt,t,tmpr
 integer :: nstep,noatmtypes 
 character(500),allocatable :: dump_files(:)
 integer, allocatable :: nframes(:),nskip(:),modtyp(:,:)

 call getarg(1,file1)
 open(unit=1,file=file1,action='read')

 file_pos_cmd=200 
! open(unit=file_pos_cmd,file='INP_CRD',action='write') 


 read(1,*)nmol_acid
 read(1,*)natoms_acid
 read(1,*)nmol_water
 read(1,*)natoms_water
 read(1,*)nmol_anion
 read(1,*)natoms_anion
 read(1,*)nmol_cation
 read(1,*)natoms_cation

 totatoms=nmol_acid*natoms_acid+nmol_water*natoms_water+nmol_anion*natoms_anion+nmol_cation*natoms_cation
 totpalmitic=nmol_acid*natoms_acid+nmol_anion*natoms_anion 

 read(1,*) box(:) 
 read(1,*) noatmtypes
 allocate(atmtypes(noatmtypes)) 

 read(1,*) atmtypes(:)
 read(1,*) nosplit             ! no of files to split into 

 read(1,*)nfiles



! write(*,*) 'enter water molecules'
! read(*,*) req_water
 req_water=500 

  allocate(store_watid(req_water))

 binwidth=0.05d0 
 dt=0.002d0    !ps 

 box2=box(3)/2 
 tmpr=0.d0 

 
 maxbin=int(box(3)/binwidth/2.d0)

 allocate(dump_file(nfiles),nframes(nfiles),nskip(nfiles))
 allocate(atm(totatoms),coor(totatoms,3))
 allocate(typ(totatoms))
 allocate(modtyp(2,natoms_acid),pos(2,nmol_acid,natoms_acid,3)) 


! read dump filenames
 do i=1,nfiles
   read(1,*)dump_file(i),nframes(i),nskip(i)
 enddo
 totframes=sum(nframes)
 totframes1=sum(nskip)
 totframes=totframes-totframes1 

 noframes_split=totframes/nosplit

 frame_no=0; nstep=0 
 hist=0 ; part_hist=0 
 counter=0
 pp=0
 do ifile=1,nfiles
   open(unit=10+ifile,file=dump_file(ifile),action='read')

   do i=1,nskip(ifile)
     do j=1,totatoms+9
        read(10+ifile,*)
     enddo
   enddo

   nframes(ifile)=nframes(ifile)-nskip(ifile)

   write(*,*) 'working on file no ',ifile,' ',trim(adjustl(dump_file(ifile))),' ... '

   do iframe=frame_no+1,frame_no+nframes(ifile)
 
    if(mod(nstep,noframes_split)==0) pp=pp+1

      nstep=nstep+1 

     if(mod(nstep,100)==0) write(*,*) 'nstep   ',nstep 

      do i=1,9
         read(10+ifile,*)
      enddo

      do i=1,totatoms
         read(10+ifile,*)j,dummyint,typ(j),coor(j,:)
        coor(j,1)=coor(j,1)-box(1)*anint(coor(j,1)/box(1))
        coor(j,2)=coor(j,2)-box(2)*anint(coor(j,2)/box(2))
        
      enddo

! zero the COM
      com=0.d0 
      do i=1,totatoms
         com=com+coor(i,:) 
      enddo 
      
      com=com/real(totatoms) 
      
      
      do i=1,totatoms
         coor(i,3)=coor(i,3)-com(3)
      enddo 



! print coordinates for monolayer

      t=nstep*dt ; tott=nmol_water*natoms_water
     
     write(file_pos_cmd+pp,'(i10,1f15.7,i10)') nstep, t, tott
     write(file_pos_cmd+pp,'(3f20.10)') box(1),tmpr,tmpr
     write(file_pos_cmd+pp,'(3f20.10)') tmpr,box(2),tmpr
      write(file_pos_cmd+pp,'(3f20.10)') tmpr,tmpr,box(3) 

! water 
      count=0 ; 
      write(55555,*) 'frame = ',nstep 
      
        do j=totpalmitic+1,totatoms
          if (typ(j)==14) then
           write (file_pos_cmd+pp,'(a8,3f15.7)') "OW",coor(j,:) 
           write (file_pos_cmd+pp,'(a8,3f15.7)') "HW",coor(j+1,:) 
           write (file_pos_cmd+pp,'(a8,3f15.7)') "HW",coor(j+2,:) 
          endif
      enddo 

    1000 continue

    enddo     ! frames 

 enddo    ! files  

 8  format(1x,a3,3(f14.7,1x))

end program aa

