! Program to idendity the indexes of water molecules participating in
! the hydrogen bonding with monolayer or water molecules
! depending on the two atom types provided in the input file
! the code identifies the water molecule indexes and also
! the code prints the factor -- whose value can be between
! 0 and 1 . This acts as a sigmoid. More details can be found
! in the manuscript 


program orien
implicit none
integer,parameter::dp=kind(0.d0)
real(kind=dp)::bin_width,vec1(3),vec2(3),vec3(3),vec4(3),dip_mag1,dip_mag2,dip_mag3,dip_mag,r, pj_mag1
real(kind=dp) :: pj_mag3,dist1,dist2,y,x,box(3),angle2
real(kind=dp)::dr(3),dist_sq,angle,angle1,func,yaxis,cut_off,cut_off_sq,dipole1(3),dipole2(3),dipole3(3),dipole(3),sum,u(3),pj1(3),pj3(3)
real(kind=dp),allocatable::coor(:,:),p2(:),p1(:),p3(:),p4(:)
integer,allocatable :: typ(:)
integer::nmol_acid,natoms_acid,nmol_water,natoms_water,tot_atoms,nfiles,maxbin,frame_no,count_frames,bin
integer::ifile,iframe,i,j,dummyint,c,counter,jj
integer,allocatable::nframes(:),nskip(:),store_watid(:)

real(kind=8),allocatable :: dvec1(:,:),dvec2(:,:),dvec3(:,:),dvec4(:,:) 

real(kind=4),allocatable :: dist_factor(:),angle_factor(:)
real(kind=8),parameter :: pi=atan(1.d0)*4.d0

character(len=100)::file1
character(len=500),allocatable::dump_file(:)

integer :: no_Catoms,k,l,m,n,xaxis,atomtyp2,atomtyp1, count

integer ::nmol_anion,nmol_cation,natoms_cation,natoms_anion,natoms_xxx,kk,ll,totpalmitic

integer ::tmp_count,s,t,count_Ow,loc,count1,count2,count3,count4,count5,count_collect
integer ::  tmpid_Ow(972),id_Ow(972)
real(kind=8) :: tmpdist_Ow(972)


call getarg(1,file1)
open(unit=1,file=file1,action='read')

 open(unit=55555,file='WATER.MOLINDEX',action='write') 
read(1,*)nmol_acid
read(1,*)natoms_acid
read(1,*)nmol_water
read(1,*)natoms_water

read(1,*)nmol_anion
read(1,*)natoms_anion
read(1,*)nmol_cation
read(1,*)natoms_cation

tot_atoms=nmol_acid*natoms_acid+nmol_water*natoms_water+nmol_anion*natoms_anion+nmol_cation*natoms_cation
totpalmitic=nmol_acid*natoms_acid+nmol_anion*natoms_anion
read(1,*) atomtyp1
read(1,*) atomtyp2
read(1,*) dist1
read(1,*) dist2
read(1,*) angle1
read(1,*) angle2
read(1,*)nfiles

!dist1=dist1*dist1 
!dist2=dist2*dist2 

x=1  

allocate(store_watid(972))
allocate(dump_file(nfiles),nframes(nfiles),nskip(nfiles))
allocate(coor(tot_atoms,3),typ(tot_atoms))
allocate(dist_factor(972),angle_factor(972))
allocate(dvec1(nmol_acid,3),dvec2(nmol_water,3),dvec3(nmol_water,3),dvec4(nmol_water,3)) 




! read dump filenames
do i=1,nfiles
   read(1,*)dump_file(i),nframes(i),nskip(i)
enddo

frame_no=0; count_frames=0
count=0 ; count1=0 ; count2=0 ; count3=0 ; count4=0 ; count5=0
counter=0
do ifile=1,nfiles
   open(unit=10+ifile,file=dump_file(ifile),action='read')

   do i=1,nskip(ifile)
     do j=1,tot_atoms+9
        read(10+ifile,*)
     enddo
   enddo

   nframes(ifile)=nframes(ifile)-nskip(ifile)

   write(*,*) 'working on file no ',ifile,' ',trim(adjustl(dump_file(ifile))),' ... '

   do iframe=frame_no+1,frame_no+nframes(ifile)
      count_frames=count_frames+1
     
      do i=1,5
         read(10+ifile,*)
      enddo

      read(10+ifile,*) x,y
      box(1)=y-x       
      read(10+ifile,*) x,y
      box(2)=y-x       
      read(10+ifile,*) x,y
      box(3)=y-x       
      read(10+ifile,*)


      l=0 ; s=0 
      do i=1,tot_atoms
         read(10+ifile,*)j,dummyint,typ(j),coor(j,:)
      enddo

      do j=1,tot_atoms 
         if(typ(j)==atomtyp1) then

             l=l+1 
             dvec1(l,:)=coor(j,:)
 
         endif 

         if(typ(j)==atomtyp2) then

             s=s+1 
             dvec2(s,:)=coor(j,:)
             dvec3(s,:)=coor(j+1,:)
             dvec4(s,:)=coor(j+2,:)
         endif 

      enddo
    
      count_Ow=0 ; id_Ow=0 
      count_collect=0
!      write(55555,*) 'frame = ',count_frames   
    do i=1,nmol_acid    ! OC 
        tmp_count=0 ; tmpid_Ow=0 
      do j=1,nmol_water    ! Ow  
   
          dip_mag1=0.d0;dip_mag=0.d0; angle=0.d0 
          dipole1=dvec2(j,:)-dvec1(i,:)
          dipole1(:)=dipole1(:)-box(:)*anint(dipole1(:)/box(:))
          dip_mag1=dot_product(dipole1(:),dipole1(:))
          dip_mag1=sqrt(dip_mag1) 

          if(dip_mag1<=dist1) then 
        

             dipole2=dvec2(j,:)-dvec3(j,:)          
             dipole2(:)=dipole2(:)-box(:)*anint(dipole2(:)/box(:))
             dip_mag2=sqrt(dot_product(dipole2(:),dipole2(:)))
             dipole3=dvec2(j,:)-dvec4(j,:)
             dipole3(:)=dipole3(:)-box(:)*anint(dipole3(:)/box(:))
             dip_mag3=sqrt(dot_product(dipole3(:),dipole3(:)))


             dipole(:)=dipole2(:)
             dip_mag=dip_mag2
             angle=dot_product(dipole1(:),dipole(:)/(dip_mag1*dip_mag))
             angle=dacos(angle)*180.d0/pi
             if(angle<=angle1) then 
                tmp_count=tmp_count+1 
                count_collect=count_collect+1
                tmpid_Ow(tmp_count)=j
                store_watid(count_collect)=j
                dist_factor(count_collect)=1.d0
                angle_factor(count_collect)=1.d0
!write(*,*)  j,i,dist_factor(j),count_collect
            elseif (angle<angle2 .and. angle>angle1)then
                tmp_count=tmp_count+1 
                count_collect=count_collect+1
                tmpid_Ow(tmp_count)=j
                store_watid(count_collect)=j
                dist_factor(count_collect)=1.d0
                angle_factor(count_collect)=1/(1+exp(2*(angle-32.5)))
             endif

             dipole(:)=dipole3(:)
             dip_mag=dip_mag3
             angle=dot_product(dipole1(:),dipole(:)/(dip_mag1*dip_mag))
             angle=dacos(angle)*180.d0/pi
             if(angle<=angle1) then
                tmp_count=tmp_count+1 
                count_collect=count_collect+1
                tmpid_Ow(tmp_count)=j
                store_watid(count_collect)=j
                dist_factor(count_collect)=1.d0
                angle_factor(count_collect)=1.d0
!write(*,*)  j,i,dist_factor(j),count_collect
            elseif (angle<angle2 .and. angle>angle1)then
                tmp_count=tmp_count+1 
                count_collect=count_collect+1
                tmpid_Ow(tmp_count)=j
                store_watid(count_collect)=j
                dist_factor(count_collect)=1.d0
                angle_factor(count_collect)=1/(1+exp(2*(angle-32.5)))
             endif

           
!write (*,*) dip_mag2,dip_mag3,dip_mag,dip_mag1,dist1, angle
!write (*,*) tmp_count

          elseif (dip_mag1>dist1 .and. dip_mag1<dist2) then

             dipole2=dvec2(j,:)-dvec3(j,:)          
             dipole2(:)=dipole2(:)-box(:)*anint(dipole2(:)/box(:))
             dip_mag2=sqrt(dot_product(dipole2(:),dipole2(:)))
             dipole3=dvec2(j,:)-dvec4(j,:)
             dipole3(:)=dipole3(:)-box(:)*anint(dipole3(:)/box(:))
             dip_mag3=sqrt(dot_product(dipole3(:),dipole3(:)))

!write(*,*) j,i,dip_mag1
             dipole(:)=dipole2(:)
             dip_mag=dip_mag2
             angle=dot_product(dipole1(:),dipole(:)/(dip_mag1*dip_mag))
             angle=dacos(angle)*180.d0/pi
             if(angle<=angle1) then 
                tmp_count=tmp_count+1 
                count_collect=count_collect+1
                tmpid_Ow(tmp_count)=j
                store_watid(count_collect)=j
                dist_factor(count_collect)=1/(1+exp(50*(dip_mag1-3.4)))
                angle_factor(count_collect)=1.d0

!write(*,*)  j,i,dist_factor(j),count_collect
            elseif (angle<angle2 .and. angle>angle1)then
                tmp_count=tmp_count+1 
                count_collect=count_collect+1
                tmpid_Ow(tmp_count)=j
                store_watid(count_collect)=j
                dist_factor(count_collect)=1/(1+exp(50*(dip_mag1-3.4)))
                angle_factor(count_collect)=1/(1+exp(2*(angle-32.5)))
             endif

             dipole(:)=dipole3(:)
             dip_mag=dip_mag3
             angle=dot_product(dipole1(:),dipole(:)/(dip_mag1*dip_mag))
             angle=dacos(angle)*180.d0/pi
             if(angle<angle1) then
                tmp_count=tmp_count+1 
                count_collect=count_collect+1
                tmpid_Ow(tmp_count)=j
                store_watid(count_collect)=j
                dist_factor(count_collect)=1/(1+exp(50*(dip_mag1-3.4)))
                angle_factor(count_collect)=1
!write(*,*)  j,i,dist_factor(j)
             elseif (angle<angle2 .and. angle>angle1)then
                tmp_count=tmp_count+1 
                count_collect=count_collect+1
                tmpid_Ow(tmp_count)=j
                store_watid(count_collect)=j
                dist_factor(count_collect)=1/(1+exp(50*(dip_mag1-3.4)))
                angle_factor(count_collect)=1/(1+exp(2*(angle-32.5)))
             endif

           endif
        enddo       ! water
            1000 continue

      enddo      ! palmitic 
      write(55555,*) 'frame ',count_frames,count_collect
      do jj=1,count_collect
        write(55555,*) store_watid(jj),min(dist_factor(jj),angle_factor(jj))
      enddo
   enddo        ! frame 
   frame_no=frame_no+nframes(ifile)
enddo

9 format(1x,I8,F15.7,F15.7,F15.7,F15.7,F15.7)

end program orien

