#!/bin/bash

#SBATCH --job-name="dip_pol_compile"
#SBATCH --partition=shared
#SBATCH --nodes=1
#SBATCH --ntasks-per-node=8
##SBATCH --mem=4000
#SBATCH -t 1:30:00
#SBATCH -o STDOUT
#SBATCH -e STDERR

cd $SLURM_SUBMIT_DIR

module load gsl

./autogen.sh

./configure CXX=mpicxx CC=mpicc --enable-maintainer-mode --disable-silent-rules PKG_CONFIG_PATH=/usr/local/lib/pkgconfig CFLAGS='-g -fopenmp -O0 -Wall -Werror -std=c99 -L/opt/gsl/2.1/intel/lib/ -I/opt/gsl/2.1/intel/include/' CXXFLAGS='-g -fopenmp -O0 -Wall -Werror -L/opt/gsl/2.1/intel/lib/ -I/opt/gsl/2.1/intel/include/'

#./configure CXX=mpicxx CC=mpicc --enable-maintainer-mode --disable-silent-rules PKG_CONFIG_PATH=/usr/local/lib/pkgconfig CFLAGS='-g -fopenmp -O1 -Wall -Werror -std=c99 -L/opt/gsl/2.1/intel/lib/ -I/opt/gsl/2.1/intel/include/' CXXFLAGS='-g -fopenmp -O1 -Wall -Werror -L/opt/gsl/2.1/intel/lib/ -I/opt/gsl/2.1/intel/include/'

./config.status

make -j12
