#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif // HAVE_CONFIG_H

#include <cmath>
#include <cassert>
#include <cstdlib>

#include <iomanip>
#include <iostream>
#include <fstream>
#include <stdexcept>

#include "read-xyz.h"

#include "mbpol.h"

namespace {

static x2o::mbpol pot;

static std::vector<tools::xyz_frame> molec;

//----------------------------------------------------------------------------//

} // namespace

////////////////////////////////////////////////////////////////////////////////

int main(int argc, char** argv)
{

    try {
	std::ifstream ifs(argv[1]);

	if (!ifs)
	    throw std::runtime_error("could not open the XYZ file");

	std::string comment;
	tools::read_xyz(argv[1], molec, true);
    } catch (const std::exception& e) {
	std::cerr << " ** Error ** : " << e.what() << std::endl;
	return 1;
    }

    for(size_t n = 0; n < molec.size(); ++n){
	const size_t nw = molec[n].nw;
	double* xyz = molec[n].xyz;

	std::cout << pot(1, xyz)+pot(1, xyz+9) << "   " 
	          << pot(nw, xyz) << std::endl;

    }

    return 0;
}
