#!/usr/bin/perl

use strict;

die "usage: sum_1d_corrfunc.pl corrfunc1.dat corrfunc2.dat ... \n"
 unless scalar @ARGV > 1;

my @x = ();
my @corr = ();
my @ncorr = ();

my $num_file = 0;
foreach (@ARGV){

    my $file = $_;
    open FH, $file
	or die "Cannot open $file for read\n";

    my $count = 0;
    while(<FH>){

	my $line = $_;
	$line =~ s/^\s+//;
	chomp($line);
	my @toks = split(/\s+/, $line);

	if(scalar @toks == 4){
	    if($num_file == 0){
	        push @x, $toks[0];
	        push @corr, $toks[2];
	        push @ncorr, $toks[3];
	    }else{
	        $corr[$count] += $toks[2];
	        $ncorr[$count] += $toks[3];
	    }
	}

	++$count;

    }
    if($count != scalar@x && $count != 0){
	die "number of data points in file '$file' != that of original file";
    }

    ++$num_file;

}

for(my $i = 0; $i < scalar@x; ++$i){
    printf "%15.8f%15.8f\n", $x[$i], $corr[$i]/$ncorr[$i];
}
