#ifndef STRUCT_INSTANT_INTERFACE_H
#define STRUCT_INSTANT_INTERFACE_H

namespace instant {

struct grid_point {
    inline grid_point();
    inline grid_point(const grid_point&);
    inline ~grid_point();

    int ix;
    int iy;
    double rz;
    double drho[3];
};

inline grid_point::grid_point()
: ix(0), iy(0), rz(0)
{
    drho[0] = 0;
    drho[1] = 0;
    drho[2] = 0;
}

inline grid_point::grid_point(const grid_point& o)
{
    ix  = o.ix;
    iy  = o.iy;
    rz  = o.rz;

    std::copy(o.drho, o.drho + 3, drho);
}

inline grid_point::~grid_point()
{
}

} // namespace instant

#endif // STRUCT_INSTANT_INTERFACE_H
