#!/bin/perl

######
#
# Question 2: Cubic Spline Interpolation
#
######

use strict;
use FindBin;
use InterpolationTools;

my @x = (1990, 1992, 1994, 1996, 1998, 2000, 2002, 2004, 2006, 2008);
my @f = (3516, 4541, 5483, 6550, 7825, 9354, 10816, 12180, 13509, 14911);

open(OUT,">p2.input_dat");

for(my $i = 0; $i < scalar@x; ++$i){
    printf OUT "%12.6f %12.6f\n", $x[$i], $f[$i];
}

close(OUT);

###
#
# part b - lagrange polynomial
#
###

open(OUT, ">p2b.out");

print "The predicted value from Lagrange Interpolation in year 2011 is:",
        &InterpolationTools::LagrangeInterpolation(\@x, \@f, 2011), "\n";

my $b = 0;
for(my $i = 1990; $i <= 2011; $i += 0.5){

    $b = &InterpolationTools::LagrangeInterpolation(\@x, \@f, $i);
    printf OUT "%12.6f %12.6f\n", $i, $b;

}
close(OUT);

###
#
# part c - cubic splines
#
###


open(OUT, ">p2c.out");

print "The predicted value from Cubic Splines in year 2011 is:",
        &InterpolationTools::CubicSpline(scalar@x - 1, \@x, \@f, 2011), "\n";

$b = 0;
for(my $i = 1990; $i <= 2011; $i += 0.5){

    $b = &InterpolationTools::CubicSpline(scalar@x - 1, \@x, \@f, $i);
    printf OUT "%12.6f %12.6f\n", $i, $b;

}
close(OUT);
