#ifndef IO_TOOLS_H
#define IO_TOOLS_H

#include <vector>
#include <string>
#include <iostream>

#include "macros.h"

#include "struct-frame.h"

namespace opt {

void print_error(size_t lineno, size_t error);

void calculate_rcell(size_t, const double*, double*);

void print_hist(std::ostream&, std::vector<opt::hist_frame>&);

void print_hist_frame(std::ostream&, opt::hist_frame&);

bool match_name(const char*, const char*);

void print_atom(std::ostream&, const char*);

} // namespace opt

#endif // IO_TOOLS_H
