#ifndef READ_HIST_H
#define READ_HIST_H

#include <vector>
#include <string>
#include <iostream>

#include "macros.h"

#include "struct-frame.h"

namespace opt {

void read_hist_frame(size_t&, std::istream&, opt::hist_frame&);
void read_cmd_frame(size_t&, std::istream&, opt::hist_frame&);
void collect_multipoles(std::istream&, std::istream&, opt::hist_frame&);
void collect_ind_multipoles(std::istream&, opt::hist_frame&);

// returns number of frames loaded
size_t read_hist(const char*, std::vector<hist_frame>&, bool multipole = false);
size_t read_cmd(std::vector<hist_frame>&, bool multipole = false);
size_t read_cmd(const char*, std::vector<hist_frame>&, bool multipole = false);

} // namespace opt

#endif // READ_HIST_H
