#ifndef STRUCT_SCAN_H
#define STRUCT_SCAN_H

namespace tools {

struct scan_frame {
    inline scan_frame();
    inline scan_frame(const scan_frame&);
    inline ~scan_frame();

    size_t npoints;
    double time;
    double* rOX;  // npoints
    double* E;  // npoints
};

inline scan_frame::scan_frame()
: npoints(0), time(0), rOX(0), E(0)
{
}

inline scan_frame::scan_frame(const scan_frame& o)
{
    npoints  = o.npoints;
    time    = o.time;
    if (npoints > 0) {
	rOX = new double[npoints];
    	std::copy(o.rOX, o.rOX + npoints, rOX);
	E = new double[npoints];
    	std::copy(o.E, o.E + npoints, E);
    }
}

inline scan_frame::~scan_frame()
{
    if (npoints > 0){
	delete[] rOX;
	delete[] E;
    }
    
}

} // namespace tools

#endif // STRUCT_SCAN_H
