#include <cmath>

#include <iostream>
#include <iomanip>

#include "alpha-ttm4.h"

const double f = 1.0; // std::pow(0.529177249, -3);


int main(int argc, char** argv)
{
    const size_t nw = 2;
    double dimer[nw*9]= { 0.00000000,   0.00000000,  0.00000000,
                          0.97554274,  -0.00000000,  0.00000000,
			  -0.23922059,   0.82397936,  0.00000000,
			  -0.16861598,  -3.51857592, -2.58572436,
			  -0.08383843,  -4.19156026, -3.36450116,
			  -0.83481841,  -2.82158426, -2.65424300};
			 
    // total polarizability
    double pt_dimer[9];
    ttm::alpha_tot(nw, dimer, pt_dimer);
    
    // 2b polarizability
    double pt_2b[9];
    ttm::alpha_no_1b(nw, dimer, pt_2b);

    // 1ba polarizability
    double pt_1b_a[9];
    ttm::alpha_tot(1, dimer, pt_1b_a);
    
    // 1bb polarizability
    double pt_1b_b[9];
    ttm::alpha_tot(1, dimer + 9, pt_1b_b);

    std::cout << "ptensor dimer: " << std::endl;
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j){
	    std::cout << std::setw(15) << pt_dimer[i*3 + j];
	}
	std::cout << std::endl;
    }
    std::cout << std::endl;

    std::cout << "ptensor 1b-a: " << std::endl;
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j){
	    std::cout << std::setw(15) << pt_1b_a[i*3 + j];
	}
	std::cout << std::endl;
    }
    std::cout << std::endl;

    std::cout << "ptensor 1b-b: " << std::endl;
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j){
	    std::cout << std::setw(15) << pt_1b_b[i*3 + j];
	}
	std::cout << std::endl;
    }
    std::cout << std::endl;

    std::cout << "ptensor 2b: " << std::endl;
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j){
	    std::cout << std::setw(15) << pt_2b[i*3 + j];
	}
	std::cout << std::endl;
    }
    std::cout << std::endl;

}
