#include <cmath>

#include <iostream>
#include <iomanip>

#include "avila.h"

int main(int argc, char** argv)
{

    x2o::avila pol_model;

    double water_molec[9] = {0.0,   0.0,   0.0,
	                     0.6,   0.4,   0.0,
			     0.4,  -0.6,   0.0};

    double a[9];
    x2o::avila::alpha(water_molec, a);

    std::cout << "In XY plane:\n";
    std::cout << std::setprecision(8);
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j)
	    std::cout << std::setw(15) << a[3*i+j] << "    ";
	std::cout << std::endl;
    }
    std::cout << std::endl;

    double water_molec2[9] = {0.0,   0.0,   0.0,
	                      0.0,   0.4,   0.6,
			      0.0,  -0.6,   0.4};

    x2o::avila::alpha(water_molec2, a);

    std::cout << "In YZ plane:\n";
    std::cout << std::setprecision(8);
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j)
	    std::cout << std::setw(15) << a[3*i+j] << "    ";
	std::cout << std::endl;
    }
    std::cout << std::endl;

    double water_molec3[9] = {1.0,   0.0,   0.0,
	                      1.0,   0.4,   0.6,
			      1.0,  -0.6,   0.4};

    x2o::avila::alpha(water_molec3, a);

    std::cout << "In YZ plane with all x = 1.0:\n";
    std::cout << std::setprecision(8);
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j)
	    std::cout << std::setw(15) << a[3*i+j] << "    ";
	std::cout << std::endl;
    }
    std::cout << std::endl;

}
