#include <cmath>

#include <iostream>

#include "avila.h"

const double f = 1.0; // std::pow(0.529177249, -3);

int main(int argc, char** argv)
{
    const double dS1 = 0.0;
    const double dS2 = 0.0*M_PI/180.0;
    const double dS3 = -0.3;

    double xyz[9];
    x2o::avila::cartesian(dS1, dS2, dS3, xyz);

    std::cout << xyz[0] << ' ' << xyz[1] << ' ' << xyz[2] << '\n'
              << xyz[3] << ' ' << xyz[4] << ' ' << xyz[5] << '\n'
              << xyz[6] << ' ' << xyz[7] << ' ' << xyz[8] << '\n';

    std::cout << "xx = " << f*x2o::avila::a_xx(dS1, dS2, dS3) << '\n'
              << "yy = " << f*x2o::avila::a_yy(dS1, dS2, dS3) << '\n'
              << "zz = " << f*x2o::avila::a_zz(dS1, dS2, dS3) << '\n'
              << "xz = " << f*x2o::avila::a_xz(dS1, dS2, dS3) << '\n';

    std::cout << "iso = " << f*(x2o::avila::a_xx(dS1, dS2, dS3)
                              + x2o::avila::a_yy(dS1, dS2, dS3)
                              + x2o::avila::a_zz(dS1, dS2, dS3))/3
              << '\n';
}
