#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif // HAVE_CONFIG_H

#include <cstdlib>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <string>
#include <iostream>

#include <cmath>
#include <cassert>

#include "interpolation.h"

int main(void)
{

    size_t N = 14;

    const double V[] = {
	21802.24489,
	21538.64621,
	21410.57441,
	21352.78110,
	21331.08374,
	21327.71619,
	21333.33265,
	21342.92474,
	21353.78868,
	21364.47657,
	21374.22863,
	21382.66373,
	21389.60204,
	21394.94227};

    const double x[] = {
         0.50000,
         0.60000,
         0.70000,
         0.80000,
         0.90000,
         1.00000,
         1.10000,
         1.20000,
         1.30000,
         1.40000,
         1.50000,
         1.60000,
         1.70000,
	 1.80000};


    const size_t nsample(2000);
    const double dx = (x[N-1] - x[0])/nsample;

    for(size_t i = 0; i < N; ++i)
	std::cout << x[i] << "   " << V[i] << std::endl;

    for(size_t i = 0; i < nsample; ++i){
	double xq = dx*i + x[0];
	double val = tools::cubic_spline(N, x, V, xq);
	std::cout << xq << "    " << val << std::endl;
    }

    return 0;
}
