#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif // HAVE_CONFIG_H

#include <cstdlib>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <string>
#include <iostream>

#include <vector>
#include <cmath>
#include <cassert>

#include "interpolation.h"

int main(void)
{

    std::vector<double> r;
    std::vector<double> g;

    while (std::cin) {
	double a, b;
	std::cin >> a >> b >> std::ws;
	if (std::cin) {
	    r.push_back(a);
	    g.push_back(b);
	}
    }

    const size_t nsample(1000);
    const double dx(0.01);

    for(size_t i = 0; i < nsample; ++i){
	double xq = dx*i;
	double val(1);

	if(xq < r[r.size() - 1])
	    val = tools::cubic_spline(r.size(), &r[0], &g[0], xq);

	std::cout << xq << "    " << val << std::endl;
    }

    return 0;
}
