#include <cmath>

#include <iostream>
#include <iomanip>

#include "avila.h"
#include "ttm4-es.h"

const double f = 1.0; // std::pow(0.529177249, -3);


int main(int argc, char** argv)
{
    const double dS1 = 0.0;
    const double dS2 = 0.0*M_PI/180.0;
    const double dS3 = -0.3;

    double xyz[9];
    x2o::avila::cartesian(dS1, dS2, dS3, xyz);

    std::cout << "xyz: " << std::endl;
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j){
	    std::cout << std::setw(15) << xyz[i*3 + j];
	}
	std::cout << std::endl;
    }
    std::cout << std::endl;

    ttm::ttm4_es ind_model;

    double Eelec, Eind;
    ind_model(1, xyz, Eelec, 0, Eind, 0);
    std::cout << "Eelec: " << Eelec << std::endl;
    std::cout << "Eind:  " << Eind << std::endl;
    std::cout << std::endl;

    double dip[3];
    ind_model.dip(1, dip);
    std::cout << "dip: " << std::endl;
    for(size_t i = 0; i < 3; ++i)
	std::cout << std::setw(15) << dip[i];
    std::cout << std::endl;

    double polind[9];
    ind_model.ptensor(1, polind);

    std::cout << std::endl;

    std::cout << "ptensor: " << std::endl;
    for(size_t i = 0; i < 3; ++i){
	for(size_t j = 0; j < 3; ++j){
	    std::cout << std::setw(15) << polind[i*3 + j];
	}
	std::cout << std::endl;
    }

}
