#include <cmath>

#include <cassert>
#include <cstdlib>
#include <sstream>
#include <iostream>
#include <iomanip>

#include "tang-toennies.h"

const double delta_r(0.1);

int main(int argc, char** argv)
{

    if(argc != 2){
	std::cerr << "usage: ./test-tang-toennies delta (1/Ang)" << std::endl;
	exit(1);
    }

    double d = 1.0;
    {
	std::istringstream iss(argv[1]);
       	iss >> d;
       	if (!iss || !iss.eof()) {
       	    std::cerr << "could not convert '" << argv[1]
       		<< "' to real number" << std::endl;
	    return EXIT_FAILURE;
	}

	assert(d > 0.0);
    }

    for(size_t i = 0; i < 100; ++i){
	double r = i*delta_r;
	double dr = r*d;
	std::cout << std::setw(15) << r
	          << std::setw(15) << dr
		  << std::setw(15) << x2o::tang_toennies(6, dr)
		  << std::endl;
    }

}
